/****************************************************************************/
/*  Copyright 2005, Trustees of Indiana University                          */
/*  Author: Sidharth Thakur                                                 */
/*  Last modified: 14 January 2006                                          */
/*  License available at: <belt-trick-* folder>/docs/downloads/License.txt  */
/****************************************************************************/
///////////////////////////////////////////////////////////////////////////////
//
// $Implemenatation:  MathObject.cpp$
//
// NAME: MathObject
//
// BASE CLASSES: none
//  
// PURPOSE: Implemenatation for class MathObject
//
// AUTHOR: Sidharth Thakur
//
///////////////////////////////////////////////////////////////////////////////

#include "MathObject.h"
#include "objectBelt.h"

MathObject::MathObject ( ) 
{
	initObject();
}

MathObject::~MathObject ( ) 
{
	cleanup();
}

void MathObject::initObject ( void ) 
{
    initBeltFirst(this);
}

void MathObject::initStructs ( void ) 
{

}

void MathObject::display ( void ) 
{
    displayBelt();
}

void MathObject::showQuaternionMap ( void ) 
{
    displayBeltQuaternionMap();
}

void MathObject::renderAxes ( void )
{
    double len = 0.5;
    double rad = 0.025;
    
    GLUquadricObj *qobj;
    qobj = gluNewQuadric();

    glutSolidSphere(0.26,16,16);
    
    glPushAttrib(GL_CURRENT_BIT | GL_LIGHTING_BIT);
		glDisable(GL_LIGHTING);
		glPushMatrix();
			glTranslatef(0.0,0.0,0.0);
			glColor3f(0.0, 0.0, 1.0);
			glRotatef(-90,1,0,0);
			gluQuadricDrawStyle(qobj, GLU_FILL);
			gluCylinder(qobj, rad, rad, len, 16, 16);
		glPopMatrix();
		glPushMatrix();
			glTranslatef(0.0,0.0,0.0);
			glColor3f(0.0, 1.0, 0.0);
			glRotatef(90,0,1,0);
			gluQuadricDrawStyle(qobj, GLU_FILL);
			gluCylinder(qobj, rad, rad, len, 16, 16);
		glPopMatrix();
		glPushMatrix();
			glTranslatef(0.0,0.0,0.0);
			glColor3f(1.0, 0.0, 0.0);
			glRotatef(0,0,0,1);
			gluQuadricDrawStyle(qobj, GLU_FILL);
			gluCylinder(qobj, rad, rad, len, 16, 16);
		glPopMatrix();
    glPopAttrib();
    
}


