/****************************************************************************/
/*  Copyright 2005, Trustees of Indiana University                          */
/*  Author: Sidharth Thakur                                                 */
/*  Last modified: 14 January 2006                                          */
/*  License available at: <belt-trick-* folder>/docs/downloads/License.txt  */
/****************************************************************************/
#include "VisibleForm.h"

#ifdef WIN32
#include <windows.h>
#include <winbase.h>
#endif

#ifndef _DEBUG_
#define _DEBUG_
#endif
//Global Variables
int			prevWidth;			//save width
int			prevHeight;			//save height
QString		str;
static QString home;
int			num_items;

VisibleForm::VisibleForm ( QWidget* parent, const char* name, bool modal, WFlags fl) 
:MainForm ( parent, name, fl )
{
	bool l_modal = modal;
	l_modal = false;

    mo = new MathObject ( );

    vp = new OGLWidgetMain ( frm_OGLScreen1, "ViewPane", this );

	vp->setGeometry ( 1,1,698,698);
	vp->setFocus();
	vp->setFocusPolicy(QWidget::StrongFocus);

	fwin_vp = new OGLWidgetFloating ( frm_OGLScreen2, "Floating Viewing Pane", this );
	fwin_vp->setGeometry ( 1,1,208,208 );

	//fwin_inst = new InstructionScreen();
	//fwin_inst->hide();
	
	#ifdef _DEBUG_
		home = QDir( "./data/index.htm" ).absPath();
	#else
		home = "../data/index.htm";
	#endif
	initForm();
	swapFrames = 0;


}

VisibleForm::~VisibleForm ( )
{
    zap(mo);
    zap(vp);
    zap(fwin_vp);
	killTimers();
}

void VisibleForm::closeEvent ( QCloseEvent *e ) 
{
	QMessageBox mb( "Exiting...",
                    "Really quit?",
                    QMessageBox::NoIcon,
                    QMessageBox::Yes | QMessageBox::Default,
                    QMessageBox::No, QMessageBox::NoButton );
	if(mb.exec() == QMessageBox::Yes) {
		e->accept();
		qApp->exit(0);
	}
}

void VisibleForm::exitApp ( void ) 
{
	fprintf(stderr,"Normal exit\n");
        qApp->exit(0);
        
}

void VisibleForm::initForm ( void )
{
	/* BELT Control initializations */

    cb_frames->setChecked(FALSE);
    cb_axes->setChecked(TRUE);
    cb_edge->setChecked(TRUE);
    cb_face->setChecked(TRUE);
	cb_belt_numbers->setChecked(FALSE);
	cb_belt_multiple_hide_rest->setChecked(FALSE);
	cb_tracker->setChecked(TRUE);

	mo->inp_slider_belt_setup_angle=100;
    rb_belt_360->setChecked(TRUE);
	mo->bpattern = BELT_PATTERN_DOUBLE_SIDED;

	//slider_belt_control_setup_angle->setValue(0);
	//slider_belt_control_setup_angle->setMaxValue(102);
	//str.sprintf("%s",": 0.000");
	//lb_belt_setup_angle->setText(str);

	slider_belt_control->setValue(0);
    str.sprintf("%s",": 0.000");
    lb_belt_angle_value->setText(str);

	slider_belt_control_width->setValue(16);
    str.sprintf("%s %.3f",": ",((double)slider_belt_control_width->value())/100.0 );
    lb_belt_width_value->setText(str);
        
    slider_belt_control_spheres_number->setEnabled(FALSE);

    slider_belt_control_numbelts->setValue(1);
    str.sprintf("%s %d",": ",slider_belt_control_numbelts->value());
    lb_belt_numbelts_value->setText(str);
        
    slider_belt_control_spheres_number->setValue(3);
    str.sprintf("%s %d",": ",(slider_belt_control_spheres_number->value()) );
    lb_belt_num_spheres->setText(str);

	rb_belt_color_plain->setChecked(TRUE);

	cbox_track_belt->insertItem(QString("None"));
	cbox_track_belt->setCurrentItem(0);
	num_items = 1;

	//fwin_inst->tbox_instructions->setEnabled(TRUE);
	rb_quat_comp_wyz->setChecked(TRUE);

	genHelpString(); 
	notifyOGLWidgets();
}

void VisibleForm::calbak_ResetApp ( void ) 
{
	vp->resetApp();
            //notifyOGLWidgets();
        vp->updateGL();
}

void VisibleForm::resizeEvent ( QResizeEvent * ) 
{
    
 //   int extraWidth  = width()- minimumWidth();
 //   int extraHeight = height()-minimumHeight();

	//frm_OGLScreen1->setGeometry( 10,10,680+extraWidth, 680+extraHeight );
	//vp->setGeometry ( frm_OGLScreen1->x()+1,frm_OGLScreen1->y()+1,678+extraWidth,678+extraHeight );
	//vp->resizeGL( vp->width(), vp->height() );
 //   //c->setGeometry(OGLFrame->x()+1,OGLFrame->y()+1,558+extraWidth, 548+extraHeight);
 //   //c->resizeGL(c->width(),c->height());
 //   //notifyOGLWidgets();

 //   extraWidth  = width()-prevWidth;
 //   extraHeight = height()-prevHeight;

 //   //controlBox->setGeometry(controlBox->x()+extraWidth,controlBox->y(),controlBox->width(),controlBox->height());
 //   
	////groupBox_ColorPalate->setGeometry(0,groupBox_ColorPalate->y()+extraHeight, groupBox_ColorPalate->width(),groupBox_ColorPalate->height());

 //   prevWidth = width();
 //   prevHeight= height();
}

void VisibleForm::notifyOGLWidgets ( void )
{
	if(vp!=NULL)
		vp->updateGL();
	if(fwin_vp != NULL)
		fwin_vp->updateGL();
}

void VisibleForm::calbak_Swap_Frames ( void )
{
	if(swapFrames == 0) {
		fwin_vp->reparent(frm_OGLScreen1, 0, QPoint(0,0), 1);
		fwin_vp->setGeometry(1,1,698,698);
		vp->reparent(frm_OGLScreen2, 0, QPoint(0,0), 1);
		vp->setGeometry(1,1,208,208);
		swapFrames = !swapFrames;
		fwin_vp->setFocus();
	}
	else {
		vp->reparent(frm_OGLScreen1, 0, QPoint(0,0), 1);
		vp->setGeometry(1,1,698,698);
		fwin_vp->reparent(frm_OGLScreen2, 0, QPoint(0,0), 1);
		fwin_vp->setGeometry(1,1,208,208);
		swapFrames = !swapFrames;
		vp->setFocus();

	}
}

void VisibleForm::timerEvent ( QTimerEvent *e )
{
	mo->inp_slider_belt_setup_angle += 5;
	//slider_belt_control_setup_angle->setValue(mo->inp_slider_belt_setup_angle);
	if(mo->inp_slider_belt_setup_angle>=102) {
        lb_status->setText("Setup belt: Complete");
		killTimer(e->timerId());
	}
	notifyOGLWidgets();
}
void VisibleForm::calbak_TimerEvent ( void )
{	
    lb_status->setText("Setup belt: Twisting belt...");
	startTimer(75);
}
/* VIEW CONTROL CALLBACKS */
void VisibleForm::calbak_ViewControl_Frames ( void )
{
	mo->showFrame = !mo->showFrame;
	notifyOGLWidgets();
}
void VisibleForm::calbak_ViewControl_Faces()
{
    mo->showFace = !mo->showFace;
    notifyOGLWidgets();
}

void VisibleForm::calbak_ViewControl_Axes()
{
    mo->showAxes = !mo->showAxes;
    notifyOGLWidgets();
}

void VisibleForm::calbak_ViewControl_EdgesOnly()
{
    mo->showEdge = !mo->showEdge;
    notifyOGLWidgets();
}

void VisibleForm::calbak_ViewControl_BeltNumbers ( ) 
{
	mo->inp_chkbox_belt_show_numbers = !mo->inp_chkbox_belt_show_numbers;
	notifyOGLWidgets();
}

void VisibleForm::calbak_ViewControl_BeltTracker ( )
{
	if(cb_tracker->isChecked())
        mo->showTracker = 1;
	else
		mo->showTracker = 0;
	notifyOGLWidgets();
}
/* Object: BELT CONTROL CALLBACKS */
void VisibleForm::calbak_Belt_Setup ( )
{
}
void VisibleForm::calbak_Belt_BoundingSpheres ( void )
{
	mo->inp_chkbox_belt_spheres = !mo->inp_chkbox_belt_spheres;
	if(mo->inp_chkbox_belt_spheres) {
	//	rb_belt_spheres_transparent->setEnabled(TRUE);
	//	rb_belt_spheres_wireframe->setEnabled(TRUE);
		slider_belt_control_spheres_number->setEnabled(TRUE);
	}
	else {
	//	rb_belt_spheres_transparent->setEnabled(FALSE);
	//	rb_belt_spheres_wireframe->setEnabled(FALSE);
	  slider_belt_control_spheres_number->setEnabled(FALSE);
	}
	notifyOGLWidgets();
}

void VisibleForm::calbak_BeltTransform_Angle ( void )
{
	mo->inp_slider_belt_angle = slider_belt_control->value();
	str.sprintf("%s %.3f",": ", mo->balpha);
	lb_belt_angle_value->setText(str);
    //lb_status->setText("Performing Belt Trick...");
	notifyOGLWidgets();
}
void VisibleForm::calbak_BeltTransform_SetupAngle ( void )
{
    //mo->inp_slider_belt_setup_angle = slider_belt_control_setup_angle->value();
    //str.sprintf("%s %.3f",": ", mo->bsetupalpha);
    //lb_belt_setup_angle->setText(str);
    //notifyOGLWidgets();
}

void VisibleForm::calbak_BeltTransform_Type ( void )
{
	if(rb_belt_360->isChecked()) {
		mo->inp_chkbox_belt_type = BELT360;
        lb_status->setText("Setup belt: Single-Twist (360-degrees)");
	}
	else if(rb_belt_720->isChecked()) {
		mo->inp_chkbox_belt_type = BELT720;
        lb_status->setText("Setup belt: Double-Twist (720-degrees)");
	}
	notifyOGLWidgets();
}

void VisibleForm::calbak_BeltTransform_Width ( )
{
	mo->inp_slider_belt_width = slider_belt_control_width->value();
	str.sprintf("%s %.3f",": ", mo->bwidth);
	lb_belt_width_value->setText(str);
	notifyOGLWidgets();
}

void VisibleForm::calbak_Belt_BSpheresMode ( void )
{
	mo->inp_chkbox_belt_spheres_wire = !mo->inp_chkbox_belt_spheres_wire;
	if(mo->inp_chkbox_belt_spheres_wire) {
		slider_belt_control_spheres_number->setEnabled(TRUE);
	}
	else {
	  slider_belt_control_spheres_number->setEnabled(FALSE);
	}	notifyOGLWidgets();
}

void VisibleForm::calbak_Belt_BSpheresNumber ( )
{
	mo->bspheresFactor = slider_belt_control_spheres_number->value();
    
    str.sprintf("%s %d",": ", mo->bspheresFactor);
    lb_belt_num_spheres->setText(str);
    notifyOGLWidgets();
        
}

void VisibleForm::calbak_BeltTransform_Multiple( void )
{
	int i = 0;
	int prev_selection = mo->flag_track_belt;

    mo->bmultiple = slider_belt_control_numbelts->value();
    str.sprintf("%s %d",": ",slider_belt_control_numbelts->value());
    lb_belt_numbelts_value->setText(str);

	//# update combo box for tracking belt
	cbox_track_belt->clear();
	cbox_track_belt->insertItem(QString("None"));
	for(i=1;i<=mo->bmultiple;i++) {
		cbox_track_belt->insertItem(QString(QString::number(i)));
	}
	
	if(cbox_track_belt->count() == prev_selection+1) {
		cbox_track_belt->setCurrentItem(cbox_track_belt->count()-1);
		mo->flag_track_belt = cbox_track_belt->count() - 2;
	}
	else {
		cbox_track_belt->setCurrentItem(prev_selection+1);
	}

    notifyOGLWidgets();
}



void VisibleForm::calbak_Belt_QuatComp       ( void )
{
    if(rb_quat_comp_wxy->isChecked()) {
        mo->qset->whichQuatComponent = SHOWWXY;
    }
    else if(rb_quat_comp_wxz->isChecked()) {
        mo->qset->whichQuatComponent = SHOWWXZ;
    }
    else if(rb_quat_comp_wyz->isChecked()) {
        mo->qset->whichQuatComponent = SHOWWYZ;
    }
    else if(rb_quat_comp_xyz->isChecked()) {
        mo->qset->whichQuatComponent = SHOWXYZ;
    }
    notifyOGLWidgets();
}
void VisibleForm::calbak_Belt_HideRest ( )
{
	if(cb_belt_multiple_hide_rest->isChecked()) 
		mo->bhiderest = 1;
	else 
		mo->bhiderest = 0;
	notifyOGLWidgets();
}
void VisibleForm::calbak_DumpScreen ( void ) 
{
        // vp->dumpscreen = 1;
        //notifyOGLWidgets();
    //vp->DumpScreen(698,698);
    vp->saveToBMP(698,698);
    
}

void VisibleForm::calbak_Belt_TrackBelt ( )
{
	//printf("Current Item = %d\n",cbox_track_belt->currentItem());
	if(cbox_track_belt->currentItem() == 0) {
		mo->flag_track_belt = -1;
		mo->bhiderest = 0;
		cb_belt_multiple_hide_rest->setChecked(FALSE);
	}
	else {
		mo->flag_track_belt = cbox_track_belt->currentItem()-1;
		mo->showFace = 1;
		cb_face->setChecked(TRUE);
	}
	vp->setFocus();

	notifyOGLWidgets();
}

void VisibleForm::calbak_Belt_ColorMode ( )
{
	if(rb_belt_color_plain->isChecked()) {
		mo->bpattern = BELT_PATTERN_DOUBLE_SIDED;
        lb_status->setText("Belt Texture: Solid-colors selected");
	}
	else {
		mo->bpattern = BELT_PATTERN_SEGMENTS;
        lb_status->setText("Belt Texture: Striped-colors selected");
	}
	notifyOGLWidgets();
}
void VisibleForm::calbak_Belt_Spine ( )
{
	////mo->bspine = !mo->bspine;
	////notifyOGLWidgets();
}
void VisibleForm::timerDone() 
{
	
}
void VisibleForm::calbak_Belt_Reset ( )
{
	mo->bsetupalpha = 0.0;
	//slider_belt_control_setup_angle->setValue(0);
	mo->inp_slider_belt_setup_angle = 0;
	calbak_BeltTransform_SetupAngle();
	mo->balpha = 0.0;
	slider_belt_control->setValue(0);
	calbak_BeltTransform_Angle();
    lb_status->setText("Setup belt: Belt has been Reset");
	notifyOGLWidgets();
}

void VisibleForm::calbak_Help(void) 
{
    //int i=0;
    //i=QMessageBox::information(this, "Help", helpstr, QMessageBox::Ok);
	help = new HelpWindow(home, ".", 0, "help viewer");
	help->show();
}

void VisibleForm::genHelpString ( void )
{
    helpstr += "Help on Mouse Interface\n";
    helpstr += "---------------------\n\n";
    helpstr += "Mouse Interface:\n";
    helpstr += "      Mouse-Left: Rotate model\n";
    helpstr += "      Mouse-Mid : Translate Tracker\n";
    helpstr += "      Mouse-Right:Scale Model\n";
    helpstr += "\n";
    helpstr += "Help on Keyboard shortcuts\n";
    helpstr += "---------------------\n\n";
    helpstr += "Global Keyboard Options:\n";
    helpstr += "   ESCAPE: Quit\n";
    helpstr += "   a: show Axes\n";
	helpstr += "   b: show Bounding-Spheres\n";
    helpstr += "   e: show Edges\n";
    helpstr += "   f: show Faces\n";
    helpstr += "   h: show Help Menu\n";
    helpstr += "   Shift+f: show Frames\n";
    helpstr += "   n: show Belt Numbers\n";
    helpstr += "   q: Swap Screens\n";
    helpstr += "   r: Reset View\n";
    helpstr += "   s: Show Central sphere\n";
    helpstr += "\n";
    helpstr += "Belt Color Options:\n";
    helpstr += "   1: Striped belt\n";
    helpstr += "   2: Solid-color belt\n";    
    helpstr += "\n";
    helpstr += "Quatenrion Component Options:\n";
    helpstr += "   w: Quaternion Map XYZ\n";
    helpstr += "   x: Quaternion Map WYZ\n";
    helpstr += "   y: Quaternion Map WXZ\n";
    helpstr += "   z: Quaternion Map WXY\n";
    helpstr += "\n";

}
